<?php

/*
////////////////////////////////////////////////////////////////////////////////
// JohnCMS                Mobile Content Management System                    //
// Project site:          http://johncms.com                                  //
// Support site:          http://gazenwagen.com                               //
////////////////////////////////////////////////////////////////////////////////
// Lead Developer:        Oleg Kasyanov   (AlkatraZ)  alkatraz@gazenwagen.com //
// Development Team:      Eugene Ryabinin (john77)    john77@gazenwagen.com   //
//                        Dmitry Liseenko (FlySelf)   flyself@johncms.com     //
////////////////////////////////////////////////////////////////////////////////
*/

defined('_IN_JOHNADM') or die('Error: restricted access');

// Проверяем права доступа
if ($rights < 9) {
    header('Location: http://youfeat.ru/?err');
    exit;
}

switch ($mod) {
    case 'new':
        /*
        -----------------------------------------------------------------
        Баним IP адрес
        -----------------------------------------------------------------
        */
        echo '<div class="phdr"><a href="index.php?act=ipban"><b>Бан по IP</b></a> | Банить</div>';
        if (isset($_POST['submit'])) {
            $error = '';
            $get_ip = isset($_POST['ip']) ? trim($_POST['ip']) : '';
            $ban_term = isset($_POST['term']) ? intval($_POST['term']) : 1;
            $ban_url = isset($_POST['url']) ? htmlentities(trim($_POST['url']), ENT_QUOTES, 'UTF-8') : '';
            $reason = isset($_POST['reason']) ? htmlentities(trim($_POST['reason']), ENT_QUOTES, 'UTF-8') : '';
            if (empty($get_ip)) {
                echo functions::display_error('Адрес введен неверно, <a href="index.php?act=ipban&amp;mod=new">Назад</a>');
                require_once('../incfiles/end.php');
                exit;
            }
            if (strstr($get_ip, '-')) {
                // Обрабатываем диапазон адресов
                $mode = 1;
                $array = explode('-', $get_ip);
                $get_ip = trim($array[0]);
                if (!$core->ip_valid($get_ip))
                    $error[] = 'Первый адрес введен неверно';
                else
                    $ip1 = ip2long($get_ip);
                $get_ip = trim($array[1]);
                if (!$core->ip_valid($get_ip))
                    $error[] = 'Второй адрес введен неверно';
                else
                    $ip2 = ip2long($get_ip);
            } elseif (strstr($get_ip, '*')) {
                // Обрабатываем адреса с маской
                $mode = 2;
                $array = explode('.', $get_ip);
                for ($i = 0; $i < 4; $i++) {
                    if (!isset($array[$i]) || $array[$i] == '*') {
                        $ipt1[$i] = '0';
                        $ipt2[$i] = '255';
                    } elseif (is_numeric($array[$i]) && $array[$i] >= 0 && $array[$i] <= 255) {
                        $ipt1[$i] = $array[$i];
                        $ipt2[$i] = $array[$i];
                    } else {
                        $error = 'Адрес введен неверно';
                    }
                    $ip1 = ip2long($ipt1[0] . '.' . $ipt1[1] . '.' . $ipt1[2] . '.' . $ipt1[3]);
                    $ip2 = ip2long($ipt2[0] . '.' . $ipt2[1] . '.' . $ipt2[2] . '.' . $ipt2[3]);
                }
            } else {
                // Обрабатываем одиночный адрес
                $mode = 3;
                if (!$core->ip_valid($get_ip)) {
                    $error = 'Адрес введен неверно';
                } else {
                    $ip1 = ip2long($get_ip);
                    $ip2 = $ip1;
                }
            }
            if (!$error) {
                // Проверка на конфликты адресов
                $req = mysql_query("SELECT * FROM `cms_ban_ip` WHERE ('$ip1' BETWEEN `ip1` AND `ip2`) OR ('$ip2' BETWEEN `ip1` AND `ip2`) OR (`ip1` >= '$ip1' AND `ip2` <= '$ip2')");
                $total = @mysql_num_rows($req);
                if ($total > 0) {
                    echo functions::display_error('Введенный Вами адрес конфликтует с другими, находящимися в базе');
                    while ($res = mysql_fetch_array($req)) {
                        echo $i % 2 ? '<div class="list2">' : '<div class="list1">';
                        $get_ip = $res['ip1'] == $res['ip2'] ? long2ip($res['ip1']) : long2ip($res['ip1']) . ' - ' . long2ip($res['ip2']);
                        echo '<a href="index.php?act=ipban&amp;mod=detail&amp;id=' . $res['id'] . '">' . $get_ip . '</a> ';
                        switch ($res['ban_type']) {
                            case 2:
                                echo 'Редирект';
                                break;

                            case 3:
                                echo 'Регистрация';
                                break;

                            default:
                                echo '<b>Блокировка</b>';
                        }
                        echo '</div>';
                        ++$i;
                    }
                    echo '<div class="phdr">Всего: ' . $total . '</div>';
                    echo '<p><a href="index.php?act=ipban&amp;mod=new">Назад</a><br /><a href="index.php">Админ панель</a></p>';
                    require_once('../incfiles/end.php');
                    exit;
                }
            }
            // Проверяем, не попадает ли IP администратора в забаниваемый диапазон
            if ($ip >= $ip1 && $ip <= $ip2)
                $error = 'Бан невозможен. Ваш собственный адрес IP попадает в диапазон';
            if (!$error) {
                // Окно подтверждения
                echo '<form action="index.php?act=ipban&amp;mod=insert" method="post">';
                switch ($mode) {
                    case 1:
                        echo '<div class="menu"><p><h3>Баним диапазон адресов</h3>&nbsp;' . long2ip($ip1) . ' - ' . long2ip($ip2) . '</p>';
                        break;

                    case 2:
                        echo '<div class="menu"><p><h3>Баним по маске подсети</h3>' . long2ip($ip1) . ' - ' . long2ip($ip2) . '</p>';
                        break;

                    default:
                        echo '<div class="menu"><p><h3>Баним адрес IP</h3>&nbsp;' . long2ip($ip1) . '</p>';
                }
                echo '<p><h3>Тип бана:</h3>&nbsp;';
                switch ($ban_term) {
                    case 2:
                        echo 'Редирект</p><p><h3>URL редиректа:</h3>&nbsp;' . (empty($ban_url) ? 'По умолчанию' : $ban_url);
                        break;

                    case 3:
                        echo 'Регистрация';
                        break;

                    default:
                        echo 'Блокировка';
                }
                echo '</p><p><h3>Причина:</h3>&nbsp;' . (empty($reason) ? 'Не указана' : $reason) . '</p>' .
                    '<input type="hidden" value="' . $ip1 . '" name="ip1" />' .
                    '<input type="hidden" value="' . $ip2 . '" name="ip2" />' .
                    '<input type="hidden" value="' . $ban_term . '" name="term" />' .
                    '<input type="hidden" value="' . $ban_url . '" name="url" />' .
                    '<input type="hidden" value="' . $reason . '" name="reason" />' .
                    '<p><input type="submit" name="submit" value=" Банить "/></p>' .
                    '</div><div class="phdr"><small>Пожалуйста проверьте правильность ввода данных</small></div>' .
                    '</form>' .
                    '<p><a href="index.php?act=ipban">Отмена</a><br /><a href="index.php">Админ панель</a></p>';
            } else {
                echo functions::display_error($error, '<a href="index.php?act=ipban&amp;mod=new">Назад</a>');
            }
        } else {
            // Форма ввода IP адреса для Бана
            echo '<form action="index.php?act=ipban&amp;mod=new" method="post">' .
                '<div class="menu"><p><h3>IP адрес:</h3>' .
                '&nbsp;<input type="text" name="ip"/></p>' .
                '<p><h3>Тип бана:</h3>' .
                '<input name="term" type="radio" value="1" checked="checked" />Блокировка<br />' .
                '<input name="term" type="radio" value="3" />Регистрация<br />' .
                '<input name="term" type="radio" value="2" />Редирект<br /></p>' .
                '<p><h3>URL редиректа</h3>' .
                '&nbsp;<input type="text" name="url"/><br />' .
                '<small>&nbsp;Необязательное поле<br />&nbsp;Адрес вводите в формате http://site.ru</small></p>' .
                '<p><h3>Причина</h3>' .
                '&nbsp;<textarea cols="20" rows="4" name="reason"></textarea>' .
                '<br /><small>&nbsp;Необязательное поле</small></p>' .
                '<p><input type="submit" name="submit" value=" Банить "/></p></div>' .
                '<div class="phdr"><small>Пример:<br /><span class="red">10.5.7.1</span> - Баним один адрес<br /><span class="red">10.5.7.1-10.5.7.100</span> - Баним диапазон адресов.<br /><span class="red">10.5.*.*</span> - Баним по маске. Будет забанена вся подсеть, начиная с адреса 0 и заканчивая 255</small></div>' .
                '</form>' .
                '<p><a href="index.php?act=ipban">Отмена</a><br /><a href="index.php">Админ панель</a></p>';
        }
        break;

    case 'insert':
        /*
        -----------------------------------------------------------------
        Проверяем адрес и вставляем в базу
        -----------------------------------------------------------------
        */
        $ip1 = isset($_POST['ip1']) ? intval($_POST['ip1']) : '';
        $ip2 = isset($_POST['ip2']) ? intval($_POST['ip2']) : '';
        $ban_term = isset($_POST['term']) ? intval($_POST['term']) : 1;
        $ban_url = isset($_POST['url']) ? functions::check($_POST['url']) : '';
        $reason = isset($_POST['reason']) ? functions::check($_POST['reason']) : '';
        if (!$ip1 || !$ip2) {
            echo functions::display_error('Адрес введен неверно, <a href="index.php?act=ipban&amp;mod=new">назад</a>');
            require_once('../incfiles/end.php');
            exit;
        }
        mysql_query("INSERT INTO `cms_ban_ip` SET
        `ip1` = '$ip1',
        `ip2` = '$ip2',
        `ban_type` = '$ban_term',
        `link` = '$ban_url',
        `who` = '$login',
        `reason` = '$reason',
        `date` = '$realtime'");
        header('Location: index.php?act=ipban');
        break;

    case 'clear':
        /*
        -----------------------------------------------------------------
        Очистка таблицы банов по IP
        -----------------------------------------------------------------
        */
        if (isset($_GET['yes'])) {
            mysql_query("TRUNCATE TABLE `cms_ban_ip`");
            header('Location: index.php?act=ipban');
        } else {
            echo '<div class="rmenu"><p><b>ВНИМАНИЕ!</b> Таблица IP банов будет очищена.<br />Вы действительно хотите разбанить IP?</p>' .
                '<p><a href="index.php?act=ipban&amp;mod=clear&amp;yes=yes">Выполнить</a> | ' .
                '<a href="index.php?act=ipban">Отмена</a></p></div>';
        }
        break;

    case 'detail':
        /*
        -----------------------------------------------------------------
        Вывод подробностей заблокированного адреса
        -----------------------------------------------------------------
        */
        echo '<div class="phdr"><a href="index.php?act=ipban"><b>Бан по IP</b></a> | Детали бана</div>';
        if ($id) {
            // Поиск адреса по ссылке (ID)
            $req = mysql_query("SELECT * FROM `cms_ban_ip` WHERE `id` = '$id'");
            $get_ip = '';
        } elseif (isset($_POST['ip'])) {
            // Поиск адреса по запросу из формы
            $get_ip = ip2long($_POST['ip']);
            if (!$get_ip) {
                echo functions::display_error('Адрес введен неверно, <a href="index.php?act=ipban&amp;mod=new">Назад</a>');
                require_once('../incfiles/end.php');
                exit;
            }
            $req = mysql_query("SELECT * FROM `cms_ban_ip` WHERE '$get_ip' BETWEEN `ip1` AND `ip2` LIMIT 1");
        } else {
            echo functions::display_error('Адрес введен неверно, <a href="index.php?act=ipban&amp;mod=new">Назад</a>');
            require_once('../incfiles/end.php');
            exit;
        }
        if (!mysql_num_rows($req)) {
            echo '<div class="menu"><p>Такого адреса в базе нет</p></div>';
            echo '<div class="phdr"><a href="index.php?act=ipban">Назад</a></div>';
            require_once('../incfiles/end.php');
            exit;
        } else {
            $res = mysql_fetch_array($req);
            $get_ip = $res['ip1'] == $res['ip2'] ? '<b>' . long2ip($res['ip1']) . '</b>' : '[<b>' . long2ip($res['ip1']) . '</b>] - [<b>' . long2ip($res['ip2']) . '</b>]';
            echo '<div class="rmenu"><p>' . $get_ip . '</p></div>';
            echo '<div class="menu"><p><h3>Тип бана</h3>&nbsp;';
            switch ($res['ban_type']) {
                case 2:
                    echo 'Редирект';
                    break;

                case 3:
                    echo 'Регистрация';
                    break;

                default:
                    echo 'Блокировка';
            }
            if ($res['ban_type'] == 2)
                echo '<br />&nbsp;' . $res['link'];
            echo '</p><p><h3>Причина</h3>&nbsp;' . (empty($res['reason']) ? 'Не указана' : $res['reason']) . '</p></div>';
            echo '<div class="menu">Банил: <b>' . $res['who'] . '</b><br />';
            echo 'Дата: <b>' . date('d.m.Y', $res['date']) . '</b><br />';
            echo 'Время: <b>' . date('H:i:s', $res['date']) . '</b></div>';
            echo '<div class="phdr"><a href="index.php?act=ipban&amp;mod=del&amp;id=' . $res['id'] . '">Удалить бан</a></div>';
            echo '<p><a href="index.php?act=ipban">В список</a><br /><a href="index.php">Админ панель</a></p>';
        }
        break;

    case 'del':
        /*
        -----------------------------------------------------------------
        Удаление выбранного IP из базы
        -----------------------------------------------------------------
        */
        if ($id) {
            if (isset($_GET['yes'])) {
                mysql_query("DELETE FROM `cms_ban_ip` WHERE `id`='$id'");
                mysql_query("OPTIMIZE TABLE `cms_ban_ip`");
                echo '<p>Бан успешно удален</p>';
                echo '<p><a href="index.php?act=ipban">Продолжить</a></p>';
            } else {
                echo '<p>Удалить Бан?</p>' .
                    '<p><a href="index.php?act=ipban&amp;mod=del&amp;id=' . $id . '&amp;yes=yes">Удалить</a> | ' .
                    '<a href="index.php?act=ipban&amp;mod=detail&amp;id=' . $id . '">Отмена</a></p>';
            }
        }
        break;

    case 'search':
        /*
        -----------------------------------------------------------------
        Форма поиска забаненного IP
        -----------------------------------------------------------------
        */
        echo '<div class="phdr"><a href="index.php?act=ipban"><b>Бан по IP</b></a> | Поиск</div>' .
            '<form action="index.php?act=ipban&amp;mod=detail" method="post"><div class="menu"><p>' .
            '<h3>IP Адрес:</h3>' .
            '<input type="text" name="ip"/>' .
            '</p><p><input type="submit" name="submit" value="Поиск"/>' .
            '</p></div><div class="phdr"><small>Вводите одиночный адрес, маска и диапазоны недопустимы</small></div>' .
            '</form>' .
            '<p><a href="index.php?act=ipban">Назад</a><br /><a href="index.php">Админ панель</a></p>';
        break;

    default:
        /*
        -----------------------------------------------------------------
        Вывод общего списка забаненных IP
        -----------------------------------------------------------------
        */
        echo '<div class="phdr"><a href="index.php"><b>Админ панель</b></a> | Бан по IP</div>';
        $req = mysql_query("SELECT COUNT(*) FROM `cms_ban_ip`");
        $total = mysql_result($req, 0);
        if ($total > 0) {
            $start = isset($_GET['page']) ? $page * $kmess - $kmess : $start;
            $req = mysql_query("SELECT * FROM `cms_ban_ip` ORDER BY `id` ASC LIMIT $start,$kmess");
            while ($res = mysql_fetch_array($req)) {
                echo $i % 2 ? '<div class="list2">' : '<div class="list1">';
                $get_ip = $res['ip1'] == $res['ip2'] ? long2ip($res['ip1']) : long2ip($res['ip1']) . ' - ' . long2ip($res['ip2']);
                echo '<a href="index.php?act=ipban&amp;mod=detail&amp;id=' . $res['id'] . '">' . $get_ip . '</a> ';
                switch ($res['ban_type']) {
                    case 2:
                        echo 'Редирект';
                        break;

                    case 3:
                        echo 'Регистрация';
                        break;

                    default:
                        echo '<b>Блокировка</b>';
                }
                echo '</div>';
                ++$i;
            }
        } else {
            echo '<div class="menu"><p>Список пуст</p></div>';
        }
        echo '<div class="rmenu"><form action="index.php?act=ipban&amp;mod=new" method="post"><input type="submit" name="" value="Банить IP" /></form></div>';
        echo '<div class="phdr">Всего: ' . $total . '</div>';
        if ($total > $kmess) {
            echo '<p>' . functions::display_pagination('index.php?act=ipban&amp;', $start, $total, $kmess) . '</p>';
            echo '<p><form action="index.php?act=ipban" method="post"><input type="text" name="page" size="2"/><input type="submit" value="К стрнице &gt;&gt;"/></form></p>';
        }
        echo '<p>';
        if ($total > 0)
            echo '<a href="index.php?act=ipban&amp;mod=search">Поиск по IP</a><br /><a href="index.php?act=ipban&amp;mod=clear">Разбанить все IP</a><br />';
        echo '<a href="index.php">Админ панель</a></p>';
}
?>