<?php

/*
////////////////////////////////////////////////////////////////////////////////
// JohnCMS                Mobile Content Management System                    //
// Project site:          http://johncms.com                                  //
// Support site:          http://gazenwagen.com                               //
////////////////////////////////////////////////////////////////////////////////
// Lead Developer:        Oleg Kasyanov   (AlkatraZ)  alkatraz@gazenwagen.com //
// Development Team:      Eugene Ryabinin (john77)    john77@gazenwagen.com   //
//                        Dmitry Liseenko (FlySelf)   flyself@johncms.com     //
////////////////////////////////////////////////////////////////////////////////
*/

define('_IN_JOHNCMS', 1);
$textl = 'Регистрация';
$rootpath = '';
require('incfiles/core.php');
require('incfiles/head.php');
// Если регистрация закрыта, выводим предупреждение
if ($core->regban || !$set['mod_reg']) {
    echo '<p>Регистрация закрыта</p>';
    require('incfiles/end.php');
    exit;
}
echo '<div class="phdr"><b>Регистрация</b></div>';
function regform() {
    echo '<form action="registration.php" method="post"><div class="gmenu">' .
        '<p><h3>Логин</h3>' .
        '<input type="text" name="nick" maxlength="15" value="' . htmlspecialchars($_POST['nick']) . '" /><br />' .
        '<small>Мин. 2, макс. 15 символов.<br />Разрешены буквы Русского и Латинского алфавита, цифры и знаки - = @ ! ? ~ _ ( ) [ ] * (кроме нуля)</small></p>' .
        '<p><h3>Пароль</h3>' .
        '<input type="text" name="password" maxlength="20" value="' . htmlspecialchars($_POST['password']) . '"/><br/>' .
        '<small>Мин. 3, макс. 10 символов.<br />Разрешены буквы Латинского алфавита и цифры</small></p>' .
        '<p><h3>Пол</h3>' .
        '<select name="sex">' .
        '<option value="?">-?-</option>' .
        '<option value="m">Мужской</option>' .
        '<option value="zh">Женский</option>' .
        '</select></p></div>' .
        '<div class="menu">' .
        '<p><h3>Имя</h3>' .
        '<input type="text" name="imname" maxlength="30" value="' . htmlspecialchars($_POST['imname']) . '" /><br />' .
        '<small>Макс. 30 символов</small></p>' .
        '<p><h3>О себе</h3>' .
        '<textarea rows="3" name="about">' . htmlspecialchars($_POST['about']) . '</textarea><br />' .
        '<small>Макс. 500 символов</small></p></div>' .
        '<div class="gmenu"><p>' .
        '<img src="captcha.php?r=' . rand(1000, 9999) . '" alt="Проверочный код" border="1"/><br />Код с картинки:<br/><input type="text" size="5" maxlength="5"  name="kod"/><br />' .
        '<small>Если Вы не видите рисунок с кодом, включите поддержку графики в настройках браузера и обновите страницу</small></p>' .
        '<p><input type="submit" name="submit" value="Зарегистрироваться"/></p></div></form>' .
        '<div class="phdr"><small>Просьба не регистрировать ники типа 111, ггг, uuuu и им подобные, они будут сразу же удалены.<br />Также будут удалены ВСЕ профили, которые регистрировались через Прокси серверы</small></div>';
}
if (isset($_POST['submit'])) {
    // Принимаем переменные
    $reg_kod = isset($_POST['kod']) ? trim($_POST['kod']) : '';
    $reg_nick = isset($_POST['nick']) ? trim($_POST['nick']) : '';
    $lat_nick = functions::rus_lat(mb_strtolower($reg_nick));
    $reg_pass = isset($_POST['password']) ? trim($_POST['password']) : '';
    $reg_name = isset($_POST['imname']) ? trim($_POST['imname']) : '';
    $reg_about = isset($_POST['about']) ? trim($_POST['about']) : '';
    $reg_sex = isset($_POST['sex']) ? trim($_POST['sex']) : '';
    $error = array ();
    // Проверка Логина
    if (empty($reg_nick))
        $error[] = 'Не введён логин';
    elseif (mb_strlen($reg_nick) < 2 || mb_strlen($reg_nick) > 15)
        $error[] = 'Недопустимая длина Логина';
    if (preg_match("/[^\da-z\-\@\*\(\)\?\!\~\_\=\[\]]+/", $lat_nick))
        $error[] = 'Ник: Недопустимые символы';
    // Проверка пароля
    if (empty($reg_pass))
        $error[] = 'Вы не ввели Пароль';
    elseif (mb_strlen($reg_pass) < 3 || mb_strlen($reg_pass) > 10)
        $error[] = 'Пароль: Недопустимая длина';
    if (preg_match("/[^\dA-Za-z]+/", $reg_pass))
        $error[] = 'Пароль: Недопустимые символы';
    // Проверка имени
    if ($reg_sex == 'm' || $reg_sex == 'zh') { }
    else
        $error[] = 'Не указан пол';
    // Проверка кода CAPTCHA
    if (empty($reg_kod) || mb_strlen($reg_kod) < 4 || $reg_kod != $_SESSION['code'])
        $error[] = 'Код с картинки введен неверно';
    unset($_SESSION['code']);
    // Проверка переменных
    if (empty($error)) {
        $pass = md5(md5($reg_pass));
        $reg_name = functions::check(mb_substr($reg_name, 0, 20));
        $reg_about = functions::check(mb_substr($reg_about, 0, 500));
        $reg_sex = functions::check(mb_substr($reg_sex, 0, 2));
        // Проверка, занят ли ник
        $req = mysql_query("SELECT * FROM `users` WHERE `name_lat`='" . mysql_real_escape_string($lat_nick) . "'");
        if (mysql_num_rows($req) != 0) {
            $error[] = 'Этот ник уже занят';
        }
    }
    if (empty($error)) {
        $preg = $set['mod_reg'] > 1 ? 1 : 0;
        mysql_query("INSERT INTO `users` SET
            `name` = '" . mysql_real_escape_string($reg_nick) . "',
            `name_lat` = '" . mysql_real_escape_string($lat_nick) . "',
            `password` = '" . mysql_real_escape_string($pass) . "',
            `imname` = '$reg_name',
            `about` = '$reg_about',
            `sex` = '$reg_sex',
            `www` = 'http://youfeat.ru',
            `rights` = '0',
            `ip` = '$ip',
            `browser` = '" . mysql_real_escape_string($agn) . "',
            `datereg` = '$realtime',
            `lastdate` = '$realtime',
            `preg` = '$preg'
        ");
        $usid = mysql_insert_id();
        echo '<div class="menu"><p><h3>Вы зарегистрированы</h3>Ваш ID: <b>' . $usid . '</b><br/>Ваш логин: <b>' . $reg_nick . '</b><br/>Ваш пароль: <b>' . $reg_pass . '</b></p>' .
            '<p><h3>Ссылка для автовхода:</h3><input type="text" value="' . $set['homeurl'] . '/login.php?id=' . $usid . '&amp;p=' . $reg_pass . '" /><br/>';
        if ($set['mod_reg'] == 1) {
            echo '<p><span class="red"><b>Пожалуйста ожидайте подтверждения Вашей регистрации администратором</b></span></p>';
        } else {
            echo '<br /><a href="login.php?id=' . $usid . '&amp;p=' . $reg_pass . '">ВХОД</a><br/><br/>';
        }
        echo '</p></div>';
    } else {
        echo functions::display_error($error);
        regform();
    }
} else {
    // Форма регистрации
    if ($set['mod_reg'] == 1) {
        echo '<div class="rmenu"><p>Вы сможете получить авторизованный доступ к разделам сайта после подтверждения Вашей регистрации.<br />Подтверждение проводится 1-2 раза в сутки</p></div>';
    }
    regform();
}

require('incfiles/end.php');
?>